'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.DEMUtils = exports.CONTROL_EVENTS = exports.GeoJSON2Feature = exports.PlanarControls = exports.FirstPersonControls = exports.FlyControls = exports.PointCloudProcessing = exports.PointsMaterial = exports.ColorLayersOrdering = exports.initTiledGeometryLayer = exports.processTiledGeometryNode = exports.updateLayeredMaterialNodeElevation = exports.updateLayeredMaterialNodeImagery = exports.FeatureProcessing = exports.pre3dTilesUpdate = exports.$3dTilesSubdivisionControl = exports.$3dTilesCulling = exports.init3dTilesLayer = exports.process3dTilesNode = exports.View = exports.Fetcher = exports.createPlanarLayer = exports.PlanarView = exports.GpxUtils = exports.createGlobeLayer = exports.GLOBE_VIEW_EVENTS = exports.GlobeView = exports.STRATEGY_DICHOTOMY = exports.STRATEGY_PROGRESSIVE = exports.STRATEGY_GROUP = exports.STRATEGY_MIN_NETWORK_TRAFFIC = exports.ImageryLayers = exports.GeometryLayer = exports.Extent = exports.UNIT = exports.Coordinates = exports.proj4 = exports.THREE = undefined;

var _proj = require('proj4');

Object.defineProperty(exports, 'proj4', {
  enumerable: true,
  get: function get() {
    return _interopRequireDefault(_proj).default;
  }
});

var _Coordinates = require('./Core/Geographic/Coordinates');

Object.defineProperty(exports, 'Coordinates', {
  enumerable: true,
  get: function get() {
    return _interopRequireDefault(_Coordinates).default;
  }
});
Object.defineProperty(exports, 'UNIT', {
  enumerable: true,
  get: function get() {
    return _Coordinates.UNIT;
  }
});

var _Extent = require('./Core/Geographic/Extent');

Object.defineProperty(exports, 'Extent', {
  enumerable: true,
  get: function get() {
    return _interopRequireDefault(_Extent).default;
  }
});

var _Layer = require('./Core/Layer/Layer');

Object.defineProperty(exports, 'GeometryLayer', {
  enumerable: true,
  get: function get() {
    return _Layer.GeometryLayer;
  }
});
Object.defineProperty(exports, 'ImageryLayers', {
  enumerable: true,
  get: function get() {
    return _Layer.ImageryLayers;
  }
});

var _LayerUpdateStrategy = require('./Core/Layer/LayerUpdateStrategy');

Object.defineProperty(exports, 'STRATEGY_MIN_NETWORK_TRAFFIC', {
  enumerable: true,
  get: function get() {
    return _LayerUpdateStrategy.STRATEGY_MIN_NETWORK_TRAFFIC;
  }
});
Object.defineProperty(exports, 'STRATEGY_GROUP', {
  enumerable: true,
  get: function get() {
    return _LayerUpdateStrategy.STRATEGY_GROUP;
  }
});
Object.defineProperty(exports, 'STRATEGY_PROGRESSIVE', {
  enumerable: true,
  get: function get() {
    return _LayerUpdateStrategy.STRATEGY_PROGRESSIVE;
  }
});
Object.defineProperty(exports, 'STRATEGY_DICHOTOMY', {
  enumerable: true,
  get: function get() {
    return _LayerUpdateStrategy.STRATEGY_DICHOTOMY;
  }
});

var _GlobeView = require('./Core/Prefab/GlobeView');

Object.defineProperty(exports, 'GlobeView', {
  enumerable: true,
  get: function get() {
    return _interopRequireDefault(_GlobeView).default;
  }
});
Object.defineProperty(exports, 'GLOBE_VIEW_EVENTS', {
  enumerable: true,
  get: function get() {
    return _GlobeView.GLOBE_VIEW_EVENTS;
  }
});
Object.defineProperty(exports, 'createGlobeLayer', {
  enumerable: true,
  get: function get() {
    return _GlobeView.createGlobeLayer;
  }
});

var _GpxUtils = require('./Core/Scheduler/Providers/GpxUtils');

Object.defineProperty(exports, 'GpxUtils', {
  enumerable: true,
  get: function get() {
    return _interopRequireDefault(_GpxUtils).default;
  }
});

var _PlanarView = require('./Core/Prefab/PlanarView');

Object.defineProperty(exports, 'PlanarView', {
  enumerable: true,
  get: function get() {
    return _interopRequireDefault(_PlanarView).default;
  }
});
Object.defineProperty(exports, 'createPlanarLayer', {
  enumerable: true,
  get: function get() {
    return _PlanarView.createPlanarLayer;
  }
});

var _Fetcher = require('./Core/Scheduler/Providers/Fetcher');

Object.defineProperty(exports, 'Fetcher', {
  enumerable: true,
  get: function get() {
    return _interopRequireDefault(_Fetcher).default;
  }
});

var _View = require('./Core/View');

Object.defineProperty(exports, 'View', {
  enumerable: true,
  get: function get() {
    return _interopRequireDefault(_View).default;
  }
});

var _dTilesProcessing = require('./Process/3dTilesProcessing');

Object.defineProperty(exports, 'process3dTilesNode', {
  enumerable: true,
  get: function get() {
    return _dTilesProcessing.process3dTilesNode;
  }
});
Object.defineProperty(exports, 'init3dTilesLayer', {
  enumerable: true,
  get: function get() {
    return _dTilesProcessing.init3dTilesLayer;
  }
});
Object.defineProperty(exports, '$3dTilesCulling', {
  enumerable: true,
  get: function get() {
    return _dTilesProcessing.$3dTilesCulling;
  }
});
Object.defineProperty(exports, '$3dTilesSubdivisionControl', {
  enumerable: true,
  get: function get() {
    return _dTilesProcessing.$3dTilesSubdivisionControl;
  }
});
Object.defineProperty(exports, 'pre3dTilesUpdate', {
  enumerable: true,
  get: function get() {
    return _dTilesProcessing.pre3dTilesUpdate;
  }
});

var _FeatureProcessing = require('./Process/FeatureProcessing');

Object.defineProperty(exports, 'FeatureProcessing', {
  enumerable: true,
  get: function get() {
    return _interopRequireDefault(_FeatureProcessing).default;
  }
});

var _LayeredMaterialNodeProcessing = require('./Process/LayeredMaterialNodeProcessing');

Object.defineProperty(exports, 'updateLayeredMaterialNodeImagery', {
  enumerable: true,
  get: function get() {
    return _LayeredMaterialNodeProcessing.updateLayeredMaterialNodeImagery;
  }
});
Object.defineProperty(exports, 'updateLayeredMaterialNodeElevation', {
  enumerable: true,
  get: function get() {
    return _LayeredMaterialNodeProcessing.updateLayeredMaterialNodeElevation;
  }
});

var _TiledNodeProcessing = require('./Process/TiledNodeProcessing');

Object.defineProperty(exports, 'processTiledGeometryNode', {
  enumerable: true,
  get: function get() {
    return _TiledNodeProcessing.processTiledGeometryNode;
  }
});
Object.defineProperty(exports, 'initTiledGeometryLayer', {
  enumerable: true,
  get: function get() {
    return _TiledNodeProcessing.initTiledGeometryLayer;
  }
});

var _ColorLayersOrdering = require('./Renderer/ColorLayersOrdering');

Object.defineProperty(exports, 'ColorLayersOrdering', {
  enumerable: true,
  get: function get() {
    return _ColorLayersOrdering.ColorLayersOrdering;
  }
});

var _PointsMaterial = require('./Renderer/PointsMaterial');

Object.defineProperty(exports, 'PointsMaterial', {
  enumerable: true,
  get: function get() {
    return _interopRequireDefault(_PointsMaterial).default;
  }
});

var _PointCloudProcessing = require('./Process/PointCloudProcessing');

Object.defineProperty(exports, 'PointCloudProcessing', {
  enumerable: true,
  get: function get() {
    return _interopRequireDefault(_PointCloudProcessing).default;
  }
});

var _FlyControls = require('./Renderer/ThreeExtended/FlyControls');

Object.defineProperty(exports, 'FlyControls', {
  enumerable: true,
  get: function get() {
    return _interopRequireDefault(_FlyControls).default;
  }
});

var _FirstPersonControls = require('./Renderer/ThreeExtended/FirstPersonControls');

Object.defineProperty(exports, 'FirstPersonControls', {
  enumerable: true,
  get: function get() {
    return _interopRequireDefault(_FirstPersonControls).default;
  }
});

var _PlanarControls = require('./Renderer/ThreeExtended/PlanarControls');

Object.defineProperty(exports, 'PlanarControls', {
  enumerable: true,
  get: function get() {
    return _interopRequireDefault(_PlanarControls).default;
  }
});

var _GeoJSON2Feature = require('./Renderer/ThreeExtended/GeoJSON2Feature');

Object.defineProperty(exports, 'GeoJSON2Feature', {
  enumerable: true,
  get: function get() {
    return _interopRequireDefault(_GeoJSON2Feature).default;
  }
});

var _GlobeControls = require('./Renderer/ThreeExtended/GlobeControls');

Object.defineProperty(exports, 'CONTROL_EVENTS', {
  enumerable: true,
  get: function get() {
    return _GlobeControls.CONTROL_EVENTS;
  }
});

var _DEMUtils = require('./utils/DEMUtils');

Object.defineProperty(exports, 'DEMUtils', {
  enumerable: true,
  get: function get() {
    return _interopRequireDefault(_DEMUtils).default;
  }
});

var _three = require('three');

var THREE = _interopRequireWildcard(_three);

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } else { var newObj = {}; if (obj != null) { for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) newObj[key] = obj[key]; } } newObj.default = obj; return newObj; } }

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

// This is temporary, until we're able to build a vendor.js
// containing our dependencies.
exports.THREE = THREE;